import { initializeApp } from "https://www.gstatic.com/firebasejs/10.6.0/firebase-app.js";
import { getMessaging, getToken, onMessage } from "https://www.gstatic.com/firebasejs/10.6.0/firebase-messaging.js";

const firebaseConfig = {
    apiKey: "AIzaSyDgsIxP2TfoelWlv_yX_qetSlfVeW76OvQ",
    authDomain: "sozcureactapp.firebaseapp.com",
    databaseURL: "https://sozcureactapp.firebaseio.com",
    projectId: "sozcureactapp",
    storageBucket: "sozcureactapp.appspot.com",
    messagingSenderId: "241108360332",
    appId: "1:241108360332:web:e03687e50ac15034e22fa9",
    measurementId: "G-YSG5R834V7"
};
const firebaseVapidKey = 'BOwN-odj49dGQgcq5jZX-WICbyH5A70jX96iYKjePgpWSOkxJPZpok_InE-Fl7KC-Lk3u2dZbAXfKSacNMB06n8';

let firebaseToken=null;
function getFirebaseToken() {

    return firebaseToken;
}
function initFirebaseMessaging() {
    const app = initializeApp(firebaseConfig);
    const messaging = getMessaging(app);

    getToken(messaging,{ vapidKey: firebaseVapidKey }).then((currentToken) => {
        if (currentToken) {
            firebaseToken = currentToken; 
            subscribeTopics(currentToken);

        } else {
            // Show permission request UI
            Notification.permission.console.log('No registration token available. Request permission to generate one.');
        }
    }).catch((err) => {
        console.log('An error occurred while retrieving token. ', err);
    });


    onMessage(messaging,function (payload) {
        
        
        console?.log('Message received. ', payload);
        return;
       
    //    window.toastMessage(payload.notification.title, payload.notification.body, payload.data.targetUrl);
        toast(payload.notification.title, payload.notification.body, payload.data.targetUrl,null,"Sözcü");

    });

    // Otherwise, we need to ask the user for permission
    if (Notification.permission !== 'granted') {
        Notification.requestPermission();
    }
}
function subscribeTopics(token){

    let key1="firebase-subs-05";
    let value1=localStorage?.getItem(key1);
    if(value1 && value1 !== undefined && value1===token){
        return;
    }

    let xmlhttp = new XMLHttpRequest();   // new HttpRequest instance
    let theUrl = "https://apiv2.sozcu.com.tr/integration/firebase/fcm/subscribe-to-topic";
    xmlhttp.open("POST", theUrl);
    xmlhttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded;");
    const params = new URLSearchParams({"firebase_token": token});
    xmlhttp.send(params);

    localStorage?.setItem(key1, token);

}

initFirebaseMessaging();

function d(e, i, s, t,c) {
    const n = `
                <div id="liveToastContainer" class="toast-container position-fixed top-0 end-0 p-3">
                    <div id="liveToast" class="toast${t !== null ? " text-bg-" + t : ""}" role="alert" aria-live="assertive" aria-atomic="true">
                        <div class="toast-header${t !== null ? " text-bg-" + t : ""}">
                            <img src="https://sozcuo01.sozcucdn.com/wp-content/themes/Sozcu_V4/assets/images/favicon.png" class="rounded me-2" height="20" alt="${c}">
                            <strong class="me-auto">${c}</strong>
                            <button type="button" class="btn-close shadow-none" data-bs-dismiss="toast" aria-label="Close"></button>
                        </div>
                        ${s !== null ? '<a href="' + s + '"' : "<div"} class="toast-body d-block">
                            <div><strong>${e}</strong></div>
                            <div class="m-0">${i}</div>
                        ${s !== null ? "</a>" : "<div>"}
                    </div>
                </div>
    `, o = document.getElementById("liveToastContainer"); o && o.remove(), document.body.insertAdjacentHTML("beforeend", n); const a = document.getElementById("liveToast"); a && a.classList.add("fade", "show")
} window.toast = d;

